<?php
/*
Plugin Name: Content4Subscribers
Plugin URI: http://websupporter.net
Description: Encourage readers to subscribe to your newsletter in order to see your blog-content
Version: 1.0
Author: Websupporter
Author URI: http://websupporter.net
License: GPLv2 or later
*/
	define( 'WP_DEBUG', true );
	if( !session_id() )
		session_start();
	
		
	define( 'C4S_DIR', dirname( __FILE__ ) . '/' );
	define( 'C4S_FILE', __FILE__ );
	require_once( C4S_DIR . 'functions.php' );
	require_once( C4S_DIR . 'includes/admin.php' );
	require_once( C4S_DIR . 'includes/classes/MailChimp.class.php' );
	require_once( C4S_DIR . 'includes/classes/CleverReach.class.php' );
	require_once( C4S_DIR . 'includes/classes/KlickTipp.class.php' );
	require_once( C4S_DIR . 'includes/classes/aweber/aweber_api/aweber_api.php' );
	
	require_once( C4S_DIR . 'includes/widgets/login.php' );
	require_once( C4S_DIR . 'includes/widgets/signup.php' );
	
	$c4s_error = false;
	$c4s_errormsg = array();
	
	function c4s_activate() {
		$options = get_option( 'c4s' );
		if( !$options ):
			$option["incl_badge"] = 1;
			$option["cleverreach_badge"] = 'cleverreach1.png';
			$option["mailchimp_badge"] = 'mailchimp1.png';
			update_option( 'c4s', $option );
		endif;
	}
	register_activation_hook( __FILE__, 'c4s_activate' );
	
	function c4s_loadlang() {	
		$plugin_dir = dirname( plugin_basename( __FILE__ ) ) . '/languages/';
		load_plugin_textdomain( 'c4s', false, $plugin_dir );
	}
	add_action('plugins_loaded', 'c4s_loadlang');
	
	add_shortcode( 'no_subscribers', 'c4s_shortcode_no_subscribers' );
	add_shortcode( 'hide', 'c4s_shortcode_hide' );
	add_shortcode( 'signup', 'c4s_shortcode_signup' );
	add_shortcode( 'lastname', 'c4s_shortcode_lastname' );
	add_shortcode( 'firstname', 'c4s_shortcode_firstname' );
	add_shortcode( 'email', 'c4s_shortcode_email' );
	
	function c4s_shortcode_firstname( $attr ){
		if( !isset( $_SESSION["c4s"]["lists"] ) )
			return "";
		
		if( isset( $attr["listid"] ) && isset( $attr["service"] ) ):
			return $_SESSION["c4s"]["lists"][ $attr["service"] ][ $attr["listid"] ]["firstname"] ;
		elseif( isset( $attr["listid"] ) ):
			foreach( $_SESSION["c4s"]["lists"] as $services ):
				foreach( $services as $key => $list ){
					if( $key == $attr["listid"] )
						return $list["firstname"];
					}
			endforeach;
		elseif( isset( $attr["service"] ) ):
			foreach( $_SESSION["c4s"]["lists"][ $attr["service"] ] as $list )
				return $list["firstname"];		
		else:
			foreach( $_SESSION["c4s"]["lists"] as $service )
				foreach( $service as $list )
					return $list["firstname"];
		endif;
		
		return "";
	}
	
	function c4s_shortcode_lastname( $attr ){
		if( !isset( $_SESSION["c4s"]["lists"] ) )
			return "";
		
		if( isset( $attr["listid"] ) && isset( $attr["service"] ) ):
			return $_SESSION["c4s"]["lists"][ $attr["service"] ][ $attr["listid"] ]["lastname"] ;
		elseif( isset( $attr["listid"] ) ):
			foreach( $_SESSION["c4s"]["lists"] as $services ):
				foreach( $services as $key => $list ){
					if( $key == $attr["listid"] )
						return $list["lastname"];
					}
			endforeach;
		elseif( isset( $attr["service"] ) ):
			foreach( $_SESSION["c4s"]["lists"][ $attr["service"] ] as $list )
				return $list["lastname"];		
		else:
			foreach( $_SESSION["c4s"]["lists"] as $service )
				foreach( $service as $list )
					return $list["lastname"];
		endif;
		
		return "";
	}
	
	function c4s_shortcode_email( $attr ){
		if( !isset( $_SESSION["c4s"]["lists"] ) )
			return "";
		
		if( isset( $attr["listid"] ) && isset( $attr["service"] ) ):
			return $_SESSION["c4s"]["lists"][ $attr["service"] ][ $attr["listid"] ]["email"] ;
		elseif( isset( $attr["listid"] ) ):
			foreach( $_SESSION["c4s"]["lists"] as $services ):
				foreach( $services as $key => $list ){
					if( $key == $attr["listid"] )
						return $list["email"];
					}
			endforeach;
		elseif( isset( $attr["service"] ) ):
			foreach( $_SESSION["c4s"]["lists"][ $attr["service"] ] as $list )
				return $list["email"];		
		else:
			foreach( $_SESSION["c4s"]["lists"] as $service )
				foreach( $service as $list )
					return $list["email"];
		endif;
		
		return "";
	}
	
	function c4s_shortcode_no_subscribers( $attr, $content ){
		global $c4s_error, $c4s_errormsg;
		$attr["service"] = strtolower( $attr["service"] );
		$hash = md5( implode( ",", $attr ) );
		$attr["hash"] = $hash;
		$attr["error"] = false;
		if( isset( $_POST["c4s"] ) && $hash == $_POST["c4s"]["hash"] ){
			$attr["error"] = $c4s_error;
			$attr["errormsg"] = $c4s_errormsg;
		}
			if(
				!isset( $_SESSION["c4s"]["lists"][ $attr["service"] ][ $attr["listid"] ]["is_subscriber"] ) or 
				!$_SESSION["c4s"]["lists"][ $attr["service"] ][ $attr["listid"] ]["is_subscriber"]  
			):
				return do_shortcode( $content );
			else:
				return "";
			endif;
	}
	
	function c4s_shortcode_hide( $attr, $content ){
		global $c4s_error, $c4s_errormsg;
		$attr["service"] = strtolower( $attr["service"] );
		$attr["content"] = $content;
		$hash = md5( implode( ",", $attr ) );
		$attr["hash"] = $hash;
		$attr["error"] = false;
		if( isset( $_POST["c4s"] ) && $hash == $_POST["c4s"]["hash"] ){
			$attr["error"] = $c4s_error;
			$attr["errormsg"] = $c4s_errormsg;
		}
		if(
				isset( $_SESSION["c4s"]["lists"][ $attr["service"] ][ $attr["listid"] ]["is_subscriber"] ) &&  
				$_SESSION["c4s"]["lists"][ $attr["service"] ][ $attr["listid"] ]["is_subscriber"]  
			):
			ob_start();			
			require_template( 'login_confirm.php', $attr );
			echo $content;
			$content = ob_get_contents();
			ob_end_clean();
			return do_shortcode( $content );
		else:
			ob_start();
			require_template( 'login.php', $attr );
			$content = ob_get_contents();
			ob_end_clean();
			return do_shortcode( $content );
		endif;
	}
	
	function c4s_shortcode_signup( $attr, $content ){
		global $c4s_error, $c4s_errormsg;
		$attr["service"] = strtolower( $attr["service"] );
		$attr["content"] = $content;
		$hash = md5( implode( ",", $attr ) );
		$attr["hash"] = $hash;
		$attr["error"] = false;
		if( isset( $_POST["c4s"] ) && $hash == $_POST["c4s"]["hash"] ){
			$attr["error"] = $c4s_error;
			$attr["errormsg"] = $c4s_errormsg;
		}
		ob_start();
		
		if( !isset( $_POST["c4s"] ) || $_POST["c4s"]["action"] != "signup" || $c4s_error )
			require_template( 'signup.php', $attr );
		else
			require_template( 'signup_confirm.php', $attr );
		c4s_signup( $attr["service"] );
		$content = ob_get_contents();
		ob_end_clean();
		return do_shortcode( $content );
	}
	
	
	function c4s_init(){
		global $c4s_error, $c4s_errormsg;
		
		if( is_file( WP_PLUGIN_DIR . '/content4subscribers-templates/style.css' ) )
			wp_register_style( 'c4s_css', WP_PLUGIN_URL . '/content4subscribers-templates/style.css' );
		else
			wp_register_style( 'c4s_css', plugins_url( 'style.css', __FILE__ ) );
		wp_enqueue_style( 'c4s_css' );
		
		wp_enqueue_script( 'jquery' );
		
		wp_register_script( 'c4s_js', plugins_url( '/js/script.js', __FILE__ ) );
		wp_enqueue_script( 'c4s_js' );
		
		
		$options = get_option( 'c4s' );
		if( isset( $_POST["c4s"] ) ):
			$c4s_error = false;
			$c4s_errormsg = array();
			
			
			$_POST["c4s"]["email"] = sanitize_email( $_POST["c4s"]["email"] );
			if( !$_POST["c4s"]["email"] ):
				$c4s_error = true;
				$c4s_errormsg[] = __( 'Please enter a valid email address', 'c4s' );
			endif;
			/*
				Login
			*/
			if( $_POST["c4s"]["action"] == "login" ):
				if( !isset( $_POST["c4s"]["listid"] ) or $_POST["c4s"]["listid"] == "" ){
					$c4s_error = true;
					$c4s_errormsg[] = __( 'Please inform the administrator. Content4Subscribers is not completly configured yet.', 'c4s' );
				}
				if( !isset( $_POST["c4s"]["service"] ) or $_POST["c4s"]["service"] == "" ){
					$c4s_error = true;
					$c4s_errormsg[] = __( 'Please inform the administrator. Content4Subscribers is not completly configured yet.', 'c4s' );
				}
				
				if( $_POST["c4s"]["service"] == "cleverreach" && !$c4s_error ):
					if( $options["cr_apikey"] != "" && !$c4s_error ){
						$api = new C4S_CleverReach( $options["cr_apikey"], $_POST["c4s"]["listid"] );
						$user = $api->getUser( $_POST["c4s"]["email"] );
						if( $user->status == "SUCCESS" && $user->data->active == 1 ){
							$_SESSION["c4s"]["lists"][ $_POST["c4s"]["service"] ][ $_POST["c4s"]["listid"] ]["is_subscriber"]  = true;
							$_SESSION["c4s"]["lists"][ $_POST["c4s"]["service"] ][ $_POST["c4s"]["listid"] ]["email"]  = $_POST["c4s"]["email"];
							foreach( $user->data->attributes as $att ):
								if( $att->key == 'firstname' ):									
									$_SESSION["c4s"]["lists"][ $_POST["c4s"]["service"] ][ $_POST["c4s"]["listid"] ]["firstname"]  = $att->value;
								elseif( $att->key == 'lastname' ):
									$_SESSION["c4s"]["lists"][ $_POST["c4s"]["service"] ][ $_POST["c4s"]["listid"] ]["lastname"]  = $att->value;
								
								endif;
							endforeach;
						} elseif( $user->status == "SUCCESS" && $user->data->active == 0 ){
							$c4s_errormsg[] = __( 'You haven\'t confirmed your subscription yet. Please check your Mailbox', 'c4s' );
							$c4s_error = true;
						} else {
							$c4s_errormsg[] = __( 'It seems, this address is not in our list. Sorry :(', 'c4s' );
							$c4s_error = true;
						}
					} else {
						$c4s_errormsg[] = __( 'Please inform the administrator. Content4Subscribers is not completly configured yet.', 'c4s' );
						$c4s_error = true;
					}	
				elseif( $_POST["c4s"]["service"] == "mailchimp" && !$c4s_error ):
					if( $options["mc_apikey"] != "" && !$c4s_error ){
						$api = new C4S_MailChimp( $options["mc_apikey"] );
						
						
						$user = $api->call('lists/member-info', array(
									'apikey'		=> $options["mc_apikey"],
									'id'			=> $_POST["c4s"]["listid"],
									'emails'		=> array( array( "email" => $_POST["c4s"]["email"] ) )
						));
						if( $user["success_count"] == 1 && $user["data"][0]["status"] == "subscribed" ):
							$_SESSION["c4s"]["lists"][ $_POST["c4s"]["service"] ][ $_POST["c4s"]["listid"] ]["is_subscriber"]  = true;
							$_SESSION["c4s"]["lists"][ $_POST["c4s"]["service"] ][ $_POST["c4s"]["listid"] ]["email"]  = $_POST["c4s"]["email"];
							$_SESSION["c4s"]["lists"][ $_POST["c4s"]["service"] ][ $_POST["c4s"]["listid"] ]["firstname"]  = $user["data"][0]["merges"]["FNAME"];
							$_SESSION["c4s"]["lists"][ $_POST["c4s"]["service"] ][ $_POST["c4s"]["listid"] ]["lastname"]  = $user["data"][0]["merges"]["LNAME"];
						elseif( $user["success_count"] == 1 && $user["data"][0]["status"] == "pending" ):
							$c4s_errormsg[] = __( 'You haven\'t confirmed your subscription yet. Please check your Mailbox', 'c4s' );
							$c4s_error = true;
						else:
							$c4s_errormsg[] = __( 'It seems, this address is not in our list. Sorry :(', 'c4s' );
							$c4s_error = true;
						endif;
					} else {
						$c4s_errormsg[] = __( 'Please inform the administrator. Content4Subscribers is not completly configured yet.', 'c4s' );
						$c4s_error = true;
					}
				endif;
				
				
			/*
				Signup
			*/
			elseif( $_POST["c4s"]["action"] == "signup" ):
				if( !isset( $_POST["c4s"]["listid"] ) or $_POST["c4s"]["listid"] == "" ){
					$c4s_error = true;
					$c4s_errormsg[] = __( 'Please inform the administrator. Content4Subscribers is not completly configured yet.', 'c4s' );
				}
				
				if( !isset( $_POST["c4s"]["service"] ) or $_POST["c4s"]["service"] == "" ){
					$c4s_error = true;
					$c4s_errormsg[] = __( 'Please inform the administrator. Content4Subscribers is not completly configured yet.', 'c4s' );
				}
					
				if( $_POST["c4s"]["firstname"] == "" ){
					$c4s_error = true;
					$c4s_errormsg[] = __( 'Please enter your first name', 'c4s' );
				}
				if( $_POST["c4s"]["lastname"] == "" ){
					$c4s_error = true;
					$c4s_errormsg[] = __( 'Please enter your last name', 'c4s' );
				}
					
				if( $_POST["c4s"]["service"] == "cleverreach" && !$c4s_error ):
					if( $options["cr_apikey"] != "" && !$c4s_error ){
						$api = new C4S_CleverReach( $options["cr_apikey"], $_POST["c4s"]["listid"] );
						$api->addUser( $_POST["c4s"]["email"], $_POST["c4s"]["firstname"], $_POST["c4s"]["lastname"], "", $_POST["c4s"]["formid"] );
					} else {
						$c4s_errormsg[] = __( 'Please inform the administrator. Content4Subscribers is not completly configured yet.', 'c4s' );
						$c4s_error = true;
					}
				elseif( $_POST["c4s"]["service"] == "mailchimp" && !$c4s_error ):
					if( $options["mc_apikey"] != "" && !$c4s_error ){
						$api = new C4S_MailChimp( $options["mc_apikey"] );
						
						$user = $api->call('lists/subscribe', array(
									'id'                => $_POST["c4s"]["listid"],
									'email'             => array( 'email' => $_POST["c4s"]["email"] ),
									'merge_vars'        => array( 'FNAME' => $_POST["c4s"]["firstname"], 'LNAME' => $_POST["c4s"]["lastname"] ),
								));
					} else {
						$c4s_errormsg[] = __( 'Please inform the administrator. Content4Subscribers is not completly configured yet.', 'c4s' );
						$c4s_error = true;
					}
				endif;
			endif;
		endif;
	}
	
	add_action( 'init', 'c4s_init' );
	
?>